Subject: [bug#27628] [PATCH 3/3] gnu: maxima: Ensure gcc and binutils available at runtime.

From: [email-masked] (Ludovic Courtès)
Date: Tue, 18 Jul 2017 16:53:11 +0200

Kei Kebreau <[email-masked]> skribis:

> [email-masked] (Ludovic Courtès) writes:
>
>> Hi Kei,
>>
>> Kei Kebreau <[email-masked]> skribis:
>>
>>> [email-masked] (Ludovic Courtès) writes:
>>>
>>>> Kei Kebreau <[email-masked]> skribis:
>>>>
>>>>> + ;; Ensure that Maxima will have access to GCC and its required
>>>>> +               ;; components at runtime.
>>>>
>>>> In fact, if it’s an optional feature, it would be better to take GCC &
>>>> co. from $PATH, because GCC is a huge dependency.  (Same for the gcl
>>>> change.)
>>>>
>>>> Thoughts?
>>>>
>>>
>>> I started on this patchset because Guix's Maxima cannot graph functions.
>>> This feature relies on GCL's 'compile' function. The 'compile' function
>>> seems to be a Common Lisp standard since at least the publication of the
>>> CLtL2 standard. Maxima assumes (correctly) that this function is present
>>> and relies on it for various base functionalities (compiling Maxima math
>>> functions to compiled Lisp functions, graphing, etc.).
>>
>> Good point, ‘compile’ is standard CL.
>>
>> So yes, that alone is probably a good reason to keep references to GCC
>> and Binutils (maybe add a comment explaining this.)  Sorry for holding
>> it back!
>>
>>> I turns out that fixing the underlying issue with GCL removes the need
>>> for GCC's presence at runtime, but binutils is still necessary due to
>>> Maxima using the 'compile' function from GCL directly. This stems from
>>> the GCC package not finding the binutils at runtime, i.e.
>>>
>>>     guix environment --pure --ad-hoc gcc -- gcc hello-world.c
>>>
>>> returns
>>>
>>>     gcc: error trying to exec 'as': execvp: No such file or directory
>>>
>>> but
>>>
>>>     guix environment --pure --ad-hoc gcc -- gcc -S hello-world.c
>>
>> You would need ‘gcc-toolchain’ rather than ‘gcc’ here.
>>
>> Thank you,
>> Ludo’.
>
> Is gcc-toolchain a package one can use as an input? lisp.scm fails to
> load properly when I use the commencement.scm module. Could this be due
> to the circular dependency problem mentioned in the "Commentary" section
> of commencement.scm?

Yeah, rather use gcc/ld-wrapper/glibc as inputs to avoid this problem.
‘gcc-toolchain’ is rather for users.

Thanks,
LUdo’.